import { Metadata, ServiceError, status } from "@grpc/grpc-js";
import type { ProtoRequest } from "./ProtoRequest";
declare type AnyProtoRequest = ProtoRequest<any, any>;
/**
 * Utility class to create errors for gRPC requests
 */
export declare class RequestError extends Error implements ServiceError {
    /**
     * Error status code
     */
    code: status;
    /**
     * Error details
     */
    details: string;
    /**
     * Request metadata
     */
    metadata: Metadata;
    /**
     * Creates custom error for gRPC requests
     * @param code Status code representing the error
     * @param request ProtoRequest instance which triggered this error
     * @param details Error details (message)
     */
    constructor(code: status, request: AnyProtoRequest, details?: string);
}
export {};
//# sourceMappingURL=RequestError.d.ts.map